#ifndef _OCCILATOR_H_INCL
#define _OCCILATOR_H_INCL

#define OCCILATOR_PART_NUM 64

enum Occilator_Type
{
    OCC_NONE,
    OCC_SQUARE,
    OCC_SINE,
    OCC_SAW,
    OCC_WT,
    OCC_NOISE,
    OCC_TRIANGLE,
};

class Occilator
{
    public:
    
        static Occilator* getInstance(Occilator_Type type,long interrupt_us);
    
        
        /**
        * Destructor
        * this destructor anatach the interval timer automatically.
        */
        ~Occilator();
        
        /**
        * Set angle speed(0x100000000 per 1 round)
        * frequency is depend on interrupt_us
        */
        void setOmega(long speed);
        
        /**
        * Set volume(0x10000 max volume)
        * @param volume 
        */
        void setVolume(int volume);
        
        /**
        * advance the Angle and caliculate value this span.
        * it was called by automatically from interval timer.
        * @return value on this tick(max 0xffff0000)
        */
        virtual unsigned long tick();
        
        long m_Angle;
        long m_Omega;
        int m_Volume;
        
        /**
        * Volume for All Channel.
        * It needs adjust output Voltage(3.3V->1V).
        * Also this volume don't change.
        */
        static void setMasterVolume(long volume);
        
protected:
    /**
    * Constructor(only)
    * to construct after mbed has started.
    * this constructor handles interval timer automatically.
    * @value interrupt_us interrupt span (micro second). it work at first time only.
    */
        Occilator(long interrupt_us);        
};
#endif